<?php
require_once 'HTTP/Client.php';
require_once 'function.mtentrypermalink.php';

$version = '0.50.1';

function smarty_block_mtbadlinkfinder($args, $content, &$ctx, &$repeat) {
    $blog = $ctx->stash('blog');
    $id = $blog['blog_id'];
    global $blog_config;
    if (!$blog_config) {
        $blog_config = array();
    }
    if (!isset($blog_config[$id])) {
        $blog_config[$id] = array();
    }
    $blog_config[$id] = $ctx->mt->db->fetch_plugin_data('BadLinkFinder', "configuration:blog:$id");
    $exclude = $args['exclude'];
    $exclude or $exclude = $blog_config[$id]['exclude'];
    $exclude or $exclude = $blog['blog_site_url'];
    $excludes = explode('|', $blog_config[$id]['exclude']);
    $charset = $ctx->mt->config('PublishCharset');
    $charset or $charset = 'utf-8';
    $content = mb_convert_encoding($content, 'HTML-ENTITIES', $charset);
    $content or $content = '&lt;img /&gt;';
    $doc = new DOMDocument();
    if (! $doc->loadHTML($content)) {
        return $content;
    }
    $http_client_default_param = array(
        'timeout' => 5,
        'allowRedirects' => false,
        ); 
    $client =& new HTTP_Client($http_client_default_param);
    $client->setDefaultHeader('User-Agent', 'BadLinkFinder/' . $version);

    $urls = array();
    $entry_url = smarty_function_mtentrypermalink($args, $ctx);
    foreach ($doc->getElementsByTagName('a') as $a) {
        $url = defragment($a->getAttribute('href'));
        if (preg_match('|^http://|', $url)
         && strcmp($url, $entry_url) != 0
         && ! found_elem_in_word($excludes, $url)) {
            if (! found_word_in_keys($url, $urls)) {
                $res = $client->head($url);
                $urls[$url] = $res;
            } else {
                $res = $urls[$url];
            }
            if ($res >= 400) {
                $attr = $a->getAttribute('class');
                $attr = add_class('badlink', $attr);
                $a->setAttribute('class', $attr);
            }
        }
    }
    return mb_convert_encoding($doc->saveHTML(), $charset, 'HTML-ENTITIES');
}

function defragment($url) {
    $a = split('#', $url);
    return $a[0];
}

function found_elem_in_word($array, $word) {
    $found = false;
    foreach ($array as $elem) {
        if (strstr($word, $elem)) {
            $found = true;
        }
    }
    return $found;
}

function found_word_in_keys($word, $array) {
    return isset($array[$word]);
}

function add_class($class, $attr) {
    if ($attr) {
        $attrs = explode(' ', $attr);
        $attr .= in_array($class, $attrs) ? '' : ' ' . $class;
    } else {
        $attr = $class;
    }
    return $attr;
}

?>
